# keystoneauth1.identity.v3.base module

class keystoneauth1.identity.v3.base.Auth(auth_url: str, auth_methods: list[AuthMethod], *, unscoped: bool = False, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True)

  Bases: `BaseAuth`

  Identity V3 Authentication Plugin.

  Parameters:

    - auth_url (string) – Identity service endpoint for authentication.

    - auth_methods (list) – A collection of methods to authenticate with.

    - trust_id (string) – Trust ID for trust scoping.

    - domain_id (string) – Domain ID for domain scoping.

    - domain_name (string) – Domain name for domain scoping.

    - project_id (string) – Project ID for project scoping.

    - project_name (string) – Project name for project scoping.

    - project_domain_id (string) – Project’s domain ID for project.

    - project_domain_name (string) – Project’s domain name for project.

    - reauthenticate (bool) – Allow fetching a new token if the current one is going to expire. (optional) default True

    - include_catalog (bool) – Include the service catalog in the returned token. (optional) default True.

    - unscoped (bool) – Force the return of an unscoped token. This will make the keystone server return an unscoped token even if a default_project_id is set for this user.

  __abstractmethods__ = frozenset({})
  __annotate_func__ = None
  __annotations_cache__ = {}
  __doc__ = "Identity V3 Authentication Plugin.\n\n:param string auth_url: Identity service endpoint for authentication.\n:param list auth_methods: A collection of methods to authenticate with.\n:param string trust_id: Trust ID for trust scoping.\n:param string domain_id: Domain ID for domain scoping.\n:param string domain_name: Domain name for domain scoping.\n:param string project_id: Project ID for project scoping.\n:param string project_name: Project name for project scoping.\n:param string project_domain_id: Project's domain ID for project.\n:param string project_domain_name: Project's domain name for project.\n:param bool reauthenticate: Allow fetching a new token if the current one\n is going to expire. (optional) default True\n:param bool include_catalog: Include the service catalog in the returned\n token. (optional) default True.\n:param bool unscoped: Force the return of an unscoped token. This will make\n the keystone server return an unscoped token even if\n a default_project_id is set for this user.\n"
  __firstlineno__ = 105
  __init__(auth_url: str, auth_methods: list[AuthMethod], *, unscoped: bool = False, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True)
  __module__ = 'keystoneauth1.identity.v3.base'
  __static_attributes__ = ('auth_methods', 'unscoped')
  _abc_impl = <_abc._abc_data object>
  add_method(method: AuthMethod) → None

    Add an additional initialized AuthMethod instance.

  get_auth_ref(session: Session) → AccessInfoV3

    Obtain a token from an OpenStack Identity Service.

    This method is overridden by the various token version plugins.

    This function should not be called independently and is expected to be invoked via the do_authenticate function.

    This function will be invoked if the AcessInfo object cached by the plugin is not valid. Thus plugins should always fetch a new AccessInfo when invoked. If you are looking to just retrieve the current auth data then you should use get_access.

    Parameters:

      session (keystoneauth1.session.Session) – A session object that can be used for communication.

    Raises:

      - keystoneauth1.exceptions.response.InvalidResponse – The response returned wasn’t appropriate.

      - keystoneauth1.exceptions.http.HttpError – An error from an invalid HTTP response.

    Returns:

      Token access information.

    Return type:

      `keystoneauth1.access.AccessInfo`

  get_cache_id_elements() → dict[str, str | None]

    Get the elements for this auth plugin that make it unique.

    As part of the get_cache_id requirement we need to determine what aspects of this plugin and its values that make up the unique elements.

    This should be overridden by plugins that wish to allow caching.

    Returns:

      The unique attributes and values of this plugin.

    Return type:

      A flat dict with a str key and str or None value. This is required as we feed these values into a hash. Pairs where the value is None are ignored in the hashed id.

class keystoneauth1.identity.v3.base.AuthConstructor(auth_url: str, *args: Any, unscoped: bool = False, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True, **kwargs: Any)

  Bases: `Auth`

  Abstract base class for creating an Auth Plugin.

  The Auth Plugin created contains only one authentication method. This is generally the required usage.

  An AuthConstructor creates an AuthMethod based on the method’s arguments and the auth_method_class defined by the plugin. It then creates the auth plugin with only that authentication method.

  __abstractmethods__ = frozenset({})
  __annotations_cache__ = {'_auth_method_class': typing.ClassVar[type[keystoneauth1.identity.v3.base.AuthMethod]]}
  __doc__ = "Abstract base class for creating an Auth Plugin.\n\nThe Auth Plugin created contains only one authentication method. This\nis generally the required usage.\n\nAn AuthConstructor creates an AuthMethod based on the method's\narguments and the auth_method_class defined by the plugin. It then\ncreates the auth plugin with only that authentication method.\n"
  __firstlineno__ = 368
  __init__(auth_url: str, *args: Any, unscoped: bool = False, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True, **kwargs: Any)
  __module__ = 'keystoneauth1.identity.v3.base'
  __static_attributes__ = ()
  _abc_impl = <_abc._abc_data object>
  _auth_method_class: ClassVar[type[AuthMethod]]

class keystoneauth1.identity.v3.base.AuthMethod(**kwargs: object)

  Bases: `object`

  One part of a V3 Authentication strategy.

  The v3 ‘/tokens’ API allow multiple methods to be presented when authentication against the server. Each one of these methods is implemented by an AuthMethod.

  Note: When implementing an AuthMethod use keyword arguments to ensure they are supported by the MultiFactor auth plugin.

  __abstractmethods__ = frozenset({'get_auth_data'})
  __annotations_cache__ = {'_method_parameters': list[str] | None}
  __dict__ = mappingproxy({'__module__': 'keystoneauth1.identity.v3.base', '__firstlineno__': 286, '__doc__': "One part of a V3 Authentication strategy.\n\nThe v3 '/tokens' API allow multiple methods to be presented when\nauthentication against the server. Each one of these methods is implemented\nby an AuthMethod.\n\nNote: When implementing an AuthMethod use keyword arguments to ensure they\nare supported by the MultiFactor auth plugin.\n", '_method_parameters': None, '__init__': <function AuthMethod.__init__>, '_extract_kwargs': <classmethod(<function AuthMethod._extract_kwargs>)>, 'get_auth_data': <function AuthMethod.get_auth_data>, 'get_cache_id_elements': <function AuthMethod.get_cache_id_elements>, '__static_attributes__': (), '__dict__': <attribute '__dict__' of 'AuthMethod' objects>, '__weakref__': <attribute '__weakref__' of 'AuthMethod' objects>, '__abstractmethods__': frozenset({'get_auth_data'}), '_abc_impl': <_abc._abc_data object>, '__annotations_cache__': {'_method_parameters': list[str] | None}})
  __doc__ = "One part of a V3 Authentication strategy.\n\nThe v3 '/tokens' API allow multiple methods to be presented when\nauthentication against the server. Each one of these methods is implemented\nby an AuthMethod.\n\nNote: When implementing an AuthMethod use keyword arguments to ensure they\nare supported by the MultiFactor auth plugin.\n"
  __firstlineno__ = 286
  __init__(**kwargs: object)
  __module__ = 'keystoneauth1.identity.v3.base'
  __static_attributes__ = ()
  __weakref__

    list of weak references to the object

  _abc_impl = <_abc._abc_data object>
  classmethod _extract_kwargs(kwargs: dict[str, object]) → dict[str, object]

    Remove parameters related to this method from other kwargs.

  _method_parameters: list[str] | None = None

    Deprecated parameter for defining the parameters supported by the plugin. These should now be defined by typed class attributes.

  abstractmethod get_auth_data(session: Session, auth: Auth, headers: dict[str, str], request_kwargs: dict[str, object]) → tuple[None, None] | tuple[str, Mapping[str, object]]

    Return the authentication section of an auth plugin.

    Parameters:

      - session (keystoneauth1.session.Session) – The communication session.

      - auth (base.Auth) – The auth plugin calling the method.

      - headers (dict) – The headers that will be sent with the auth request if a plugin needs to add to them.

    Returns:

      The identifier of this plugin and a dict of authentication data for the auth type.

    Return type:

      tuple(string, dict)

  get_cache_id_elements() → dict[str, str | None]

    Get the elements for this auth method that make it unique.

    These elements will be used as part of the `keystoneauth1.plugin.BaseIdentityPlugin.get_cache_id()` to allow caching of the auth plugin.

    Plugins should override this if they want to allow caching of their state.

    To avoid collision or overrides the keys of the returned dictionary should be prefixed with the plugin identifier. For example the password plugin returns its username value as ‘password_username’.

class keystoneauth1.identity.v3.base.BaseAuth(auth_url: str, *, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True)

  Bases: `BaseIdentityPlugin`

  Identity V3 Authentication Plugin.

  Parameters:

    - auth_url (string) – Identity service endpoint for authentication.

    - trust_id (string) – Trust ID for trust scoping.

    - system_scope (string) – System information to scope to.

    - domain_id (string) – Domain ID for domain scoping.

    - domain_name (string) – Domain name for domain scoping.

    - project_id (string) – Project ID for project scoping.

    - project_name (string) – Project name for project scoping.

    - project_domain_id (string) – Project’s domain ID for project.

    - project_domain_name (string) – Project’s domain name for project.

    - reauthenticate (bool) – Allow fetching a new token if the current one is going to expire. (optional) default True

    - include_catalog (bool) – Include the service catalog in the returned token. (optional) default True.

  __abstractmethods__ = frozenset({'get_auth_ref'})
  __annotations_cache__ = {'auth_url': <class 'str'>}
  __doc__ = "Identity V3 Authentication Plugin.\n\n:param string auth_url: Identity service endpoint for authentication.\n:param string trust_id: Trust ID for trust scoping.\n:param string system_scope: System information to scope to.\n:param string domain_id: Domain ID for domain scoping.\n:param string domain_name: Domain name for domain scoping.\n:param string project_id: Project ID for project scoping.\n:param string project_name: Project name for project scoping.\n:param string project_domain_id: Project's domain ID for project.\n:param string project_domain_name: Project's domain name for project.\n:param bool reauthenticate: Allow fetching a new token if the current one\n is going to expire. (optional) default True\n:param bool include_catalog: Include the service catalog in the returned\n token. (optional) default True.\n"
  __firstlineno__ = 31
  __init__(auth_url: str, *, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True)
  __module__ = 'keystoneauth1.identity.v3.base'
  __static_attributes__ = ('domain_id', 'domain_name', 'include_catalog', 'project_domain_id', 'project_domain_name', 'project_id', 'project_name', 'system_scope', 'trust_id')
  _abc_impl = <_abc._abc_data object>
  auth_url: str
  property has_scope_parameters: bool

    Return true if parameters can be used to create a scoped token.

  property token_url: str

    The full URL where we will send authentication data.

this page last updated: 2026-07-14 15:48:40

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug